<?php

class SharePage extends Page
{
  var $FullTitle = 'Prohledávání sdílených souborů';
  var $ShortTitle = 'Sdílené soubory';
  var $ParentClass = 'PagePortal';
  var $Dependencies = array('Log');
  var $MaxNesting = 20; // Maximální vnoření
  var $Promene = array( // Automatické zapamatování proměnných
    'keyword' => '',
    'file_type' => 0,
    'size' => '',
    'size_method' => 1,
    'size_units' => 2,
    'online' => 'on',
    'order' => 'size DESC',
    'page' => '0',
    'view' => 1,
  );

  function ShowTime()
  {
    return date("H:i:s")."<br />\n";
  }

  // Inicializace Logu
  //$LogFile = fopen('info.log','w');
  function Loguj($Info)
  {
    //global $LogFile;
    //fputs($LogFile,$Info."\n");
  }
  //Show_Array($GLOBALS);

    // Najde cestu ke keřenu
  function PlnaCesta($Row)
  {
    // Vyhledání cesty
    $Otec = $Row['Parent'];
    $Cesta = ''; //$Row['name'];
    $i = 0;
    while (($Otec > 1) && ($i < $this->MaxNesting))
    {
      $DbResult = $this->Database->query('SELECT Id,Name,Parent FROM NetworkShareItem WHERE Id='.$Otec);
      $Row = $DbResult->fetch_array();
      $this->Loguj('Name: '.$Row['Name'].' ID:'.$Row['Id'].' Parent:'.$Row['Parent']);
      $Cesta = $Row['Name'].'\\'.$Cesta;
      $Otec = $Row['Parent'];
      $i++;
    }
    if ($i >= $this->MaxNesting) $Cesta = '?'.'\\'.$Cesta;
    return '\\\\'.$Cesta;
  }

  // Převede velikost v bajtech na odpovídající jednotky
  function PrevedVelikost($Velikost)
  {
    $Jednotky = array('B','kB','MB','GB','TB','PB','EB');
    while ($Velikost >= 1024)
    {
      $Velikost = round($Velikost / 1024 * 10) / 10;
      array_shift($Jednotky);
    }
    return $Velikost.'&nbsp;'.$Jednotky[0];
  }

  function Show()
  {
    if (!$this->System->User->CheckPermission('NetworkShare', 'Display')) return 'Nemáte oprávnění';

    // If not only online checkbox checked
    if (array_key_exists('view', $_POST) and !array_key_exists('online', $_POST)) $_POST['online'] = 'off';

    // Default host list view
    if ((count($_POST) == 0) and (count($_GET) == 0))
    {
      $_POST['view'] = 1;
      $_POST['page'] = 0;
    }

    // Toggle order direction
    if (array_key_exists('order', $_GET) and ($_SESSION['order'] == $_GET['order'])) $_GET['order'] .= ' DESC';

    //print_r($_POST);
    foreach ($this->Promene as $Index => $Prvek)
    {
      if (!array_key_exists($Index, $_SESSION)) $_SESSION[$Index] = $this->Promene[$Index];
      if (array_key_exists($Index, $_GET)) $_SESSION[$Index] = $_GET[$Index];
      if (array_key_exists($Index, $_POST)) $_SESSION[$Index] = $_POST[$Index];
      if (($Index == 'keyword') and (array_key_exists('view', $_GET))) $_SESSION[$Index] = $this->Promene[$Index];
      if (($Index == 'view') and ((array_key_exists('keyword', $_POST)) or (array_key_exists('keyword', $_GET)))) $_SESSION[$Index] = '';
      $$Index = $_SESSION[$Index];
      //echo('$'.$Index.' = '.$_SESSION[$Index].'<br>');
    }
    //echo($keyword);
    //if ($keyword)
    //if ($keyword != '') $view = '';

    //$this->Database->select_db('share');

    // Log search
    if (array_key_exists('keyword', $_POST) or array_key_exists('keyword', $_GET))
      $this->System->ModuleManager->Modules['Log']->NewRecord('Share', 'Hledaný výraz', $_SESSION['keyword']);

    // Zobrazení formuláře
    $Output = '<form action="?" method="post">
    <input type="hidden" name="view" value="">
    <input type="hidden" name="page" value="0">
    Hledat: <input type="text" name="keyword" value="'.$keyword.'">';
    $Output .= '<input type="submit" value="Hledat">&nbsp;Typ: <select name="file_type" id="file_type">';
    $Selected = array('', '', '', '', '', '', '', '');
    $Selected[$file_type] = 'selected ';
    $Output .= '<option '.$Selected[0].'value="0">Vše
    <option '.$Selected[1].'value="1">Audio(mp3,wav,ogg,mid)
    <option '.$Selected[2].'value="2">Dokument(doc,txt,pdf)
    <option '.$Selected[3].'value="3">Komprimovaný(zip,rar,ace,tar)
    <option '.$Selected[4].'value="4">Video(mpeg,avi,ogm,mkv,asf)
    <option '.$Selected[5].'value="5">Obrázek(jpg,bmp,gif,png)
    <option '.$Selected[6].'value="6">Složka
    <option '.$Selected[7].'value="7">Spustitelný(exe,com)
    <option '.$Selected[7].'value="8">Obraz disku(iso,nrg,ccd,bin)
    </select>
    &nbsp;Velikost: <select name="size_method">';
    $Selected = array('', '', '');
    $Selected[$size_method] = 'selected ';
    $Output .= '<option '.$Selected[0].'value="0">Rovno
    <option '.$Selected[1].'value="1">Nejméně
    <option '.$Selected[2].'value="2">Nejvíce
    </select>
    <input type="edit" size="5" name="size" value="'.$size.'">
    <select name="size_units">';
    $Selected = array('', '', '', '');
    $Selected[$size_units] = 'selected ';
    $Output .= '<option '.$Selected[0].'value="0">B
    <option '.$Selected[1].'value="1">kB
    <option '.$Selected[2].'value="2">MB
    <option '.$Selected[3].'value="3">GB
    </select>&nbsp;';

    if ($online == 'on') $Selected = 'checked '; else $Selected = '';
    $Output .= '<input type="checkbox" '.$Selected.'name="online">Pouze aktivní uživatele<br>
    </form>';

    //$Output .= $view;
    if ($view != '')
    {
      // Zobrazení obsahu vybrané složky
      $DbResult = $this->Database->query('SELECT * FROM NetworkShareItem WHERE id='.$view);
      $Row = $DbResult->fetch_array();
      $Cesta = $this->PlnaCesta($Row);
      $Output .= '<strong>Obsah složky: '.$Cesta.$Row['name'].'</strong><br />';
      $Podminka = '(Parent='.$view.')';
      $Nahoru = $Row['Parent'];
    } else
    {
      // Zobrazení výsledku vyhledávání
      $Output .= '<strong>Výsledek hledání:</strong><br />';
      $Podminka = "(Name LIKE '%".strtr($keyword, '*', '%')."%')";

      // Hledání podle typů
      $Pripony = array('',
        "(ext LIKE 'mp3') OR (ext LIKE 'wav') OR (ext LIKE 'ogg') OR (ext LIKE 'mid')",
        "(ext LIKE 'doc') OR (ext LIKE 'txt') OR (ext LIKE 'pdf')",
        "(ext LIKE 'zip') OR (ext LIKE 'rar') OR (ext LIKE 'ace') OR (ext LIKE 'tar')",
        "(ext LIKE 'mpeg') OR (ext LIKE 'mpg') OR (ext LIKE 'avi') OR (ext LIKE 'ogm') OR (ext LIKE 'mkv') OR (ext LIKE 'asf')",
        "(ext LIKE 'jpg') OR (ext LIKE 'gif') OR (ext LIKE 'bmp') OR (ext LIKE 'ico') OR (ext LIKE 'png')",
        "(type='2')",
        "(ext LIKE 'exe') OR (ext LIKE 'com')",
        "(ext LIKE 'iso') OR (ext LIKE 'nrg') OR (ext LIKE 'ccd') OR (ext LIKE 'bin') OR (ext LIKE 'mds')",
      );
      if ($file_type > 0) $Podminka .= ' AND ('.$Pripony[$file_type].')';

      //Hledání podle velikosti
      $Jednotky = array(1, 1024, 1048576, 1073741824);
      if (is_numeric($size))
      {
        $Metoda = array('=', '>', '<');
        $Velikost = $size * $Jednotky[$size_units];
        $Podminka .= ' AND (Size'.$Metoda[$size_method].$Velikost.')';
      }
    }

    // Omezení na online/offline uživatele
    //$this->Database->select_db('is');
    if ($online == 'on') $DbResult = $this->Database->query('SELECT Id FROM NetworkDevice WHERE Online=1 AND Member IS NOT NULL');
      else $DbResult = $this->Database->query('SELECT Id FROM NetworkDevice');
    $Vyber = '';
    while ($Row = $DbResult->fetch_array()) $Vyber .= $Row['Id'].',';
    $Podminka .= ' AND (Host IN ('.substr($Vyber, 0, -1).'))';
    //echo($Podminka.'<br>');
    //$this->Database->select_db('share');

    //ShowTime();

    // Zjištění počtu výskytů
    //DB_Query("SELECT COUNT(*) FROM NetworkShareItem WHERE ($Podminka)");
    //$Row = DB_Row();
    //$Pocet = $Row[0];

    // Zobrazení [..]
    if (($view != '') && ($page == 0) && ($Nahoru > 0))
    {
      $DbResult = $this->Database->query('SELECT * FROM NetworkShareItem WHERE Id='.$view);
      $Row = $DbResult->fetch_array();
      //ShowArray($Row);
      $Datum = explode(' ', $Row['date']);
      $upstr = '<tr><td bgcolor="#F0F0FF"><a href="index.php?view='.$Nahoru.'">[..]</a></td><td bgcolor="#F0F0FF" width="1%"></td><td align="right" bgcolor="#F0F0FF" width="1%">'.$this->PrevedVelikost($Row['size']).'</td><td bgcolor="#F0F0FF" width="90">'.$Datum[0].'</td><td bgcolor="#F0F0FF" width="50%">'.$Cesta.'</td></tr>';
    } else $upstr = '';

    // Nacteni vysledku z databaze
    $PerPage = 30;
    $Dotaz = "SELECT COUNT(*) FROM NetworkShareItem WHERE (".$Podminka.")";
    if ($order != '') $Dotaz .= ' ORDER BY '.$order;
    $Dotaz .= " LIMIT ".($page * $PerPage).",".$PerPage;
    $DbResult = $this->Database->query($Dotaz);
    $Row = $DbResult->fetch_array();
    $Pocet = $Row[0];

    if ($Pocet > 0)
    {
      $Output .= 'Nalezeno celkem: '.$Pocet.' položek<br />';
    } else
    $Output .= 'Podle zadaných podmínek nic nenalezeno';
    if (($Pocet > 0) || ($upstr))
    {
      $Output .= '<table width="100%" style="font-size: 8pt;" border="0" cellpadding="2" cellspacing="2">
      <tr><th bgcolor="#E0E0FF"><a href="index.php?order=name">Soubor</a></th><th bgcolor="#E0E0FF"><a href="index.php?order=ext">Přípona</a></th><th bgcolor="#E0E0FF"><a href="index.php?order=size">Velikost</a></th><th bgcolor="#E0E0FF"><a href="index.php?order=date">Datum</a></th><th bgcolor="#E0E0FF">Umístění</th></tr>';
      $Output .= $upstr;
      if ($Pocet > 0)
      {
        // Zobrazení tabulky s výsledky
        $Pages = floor($Pocet / $PerPage);
        // echo($Dotaz);

        // Zobrazení poloľek
        while ($Row = $DbResult->fetch_array())
        {
          // Loguj('Radek '.$Row['name']);
          $Radek = $Row;
          $Cesta = $this->PlnaCesta($Row);
          $Datum = explode(' ', $Radek['Date']);

          // Zobrazení řádku
          $Cesta2 = strtr($Cesta.$Radek['Name'], '\\', '/');
          if ($Radek['Ext'] != '') $Cesta2 .= '.'.$Radek['Ext'];
          if ($Radek['Type'] != 0) $Adresa = 'index.php?view='.$Radek['Id'].'">['.$Radek['Name'].']';
          else
          {
            if (strstr($_SERVER['HTTP_USER_AGENT'], 'Linux')) $Adresa = 'smb:'.$Cesta2.'">'.$Radek['Name'];
            else $Adresa = 'file:///'.$Cesta2.'">'.$Radek['Name'];
          }
          $Output .= '<tr><td bgcolor="#F0F0FF"><a href="'.$Adresa.'</a></td>'.
            '<td bgcolor="#F0F0FF" width="1%">'.$Radek['Ext'].'</td>'.
            '<td align="right" bgcolor="#F0F0FF" width="1%">'.$this->PrevedVelikost($Radek['Size']).'</td>'.
            '<td bgcolor="#F0F0FF" width="90">'.$Datum[0].'</td>'.
            '<td bgcolor="#F0F0FF" width="50%" >'.$Cesta.'</td></tr>';
        }
        $Output .= '</table>';
      }
    }
    if ($Pocet > 0)
    {
      // Celkový přehled
      if ($view == 1)
      {
        $DbResult = $this->Database->query('SELECT SUM(Size) FROM NetworkShareItem WHERE (Parent=1) AND (Host IN ('.substr($Vyber,0,-1).'))');
        $Row = $DbResult->fetch_array();
        $SizeOnline = $this->PrevedVelikost($Row[0]);
        $DbResult = $this->Database->query('SELECT Size FROM NetworkShareItem WHERE Id=1');
        $Row = $DbResult->fetch_array();
        $Size = $this->PrevedVelikost($Row['size']);
        $DbResult = $this->Database->query('SELECT COUNT(*) FROM NetworkShareItem');
        $Row = $DbResult->fetch_array();
        $Output .= '<br />Celková velikost online sdílených dat: '.$SizeOnline;
        $Output .= '<br />Celkem v databázi '.$Row[0].' položek o celkové velikosti '.$Size.'<br />';
        $Output .= '<br /><strong>Popis služby:</strong><br />
        Tento vyhledávač slouží k prohledávání obsahu samba sdílení všech uživatelů. Je postaven na filosofii, čím více lidí bude sdílet data, tím větší bude pravděpodobnost, že najdete to co hledáte. Každý počítač je jednou za den oskenován a informace o jeho sdílení jsou zaneseny do databáze. Každou hodinu probíhá kontrola zapnutých počítačů a jejich případné oskenování. Při hledání použíjte znak * podobně jako při vyhledávání souborů na disku.<br><br>
        <a href="firefox.php">Vyhledávání přes internetový prohlížeč Firefox</a><br />';
        $Output .= '<a href="playlist.php">WinAMP playlist mp3 souborů online počítačů</a><br /><br />';

        // Zobrazení chyb sdílení
        $Host = gethostbyaddr(GetRemoteAddress());
        //echo($Host);
        $Host = strtoupper(substr($Host, 0, strpos($Host, '.')));
        $DbResult = $this->Database->select('NetworkShareError', '*', 'Host="'.$Host.'"');
        if ($DbResult->num_rows > 0) $Output .= '<strong>Výpis chybových hlášení pro počítač '.$Host.':</strong><br />';
        //echo('host="'.$Host.'"');
        while ($Row = $DbResult->fetch_array())
        {
          $Row['Message'] = str_replace('/', '\\', $Row['Message']);
          $Output .= $Row['Message'].'<br />';
        }
      }

      // Zobrazení seznamu stránek
      if ($Pages > 1)
      {
        if ($page > 0) $Output .= '<a href="index.php?page=0">&lt;&lt;</a> ';
        if ($page > 0) $Output .= '<a href="index.php?page='.($page-1).'">&lt;</a> ';
        $PagesMax = $Pages;
        $PagesMin = 0;
        if ($PagesMax > ($page + 10)) $PagesMax = $page + 10;
        if ($PagesMin < ($page - 10))
        {
          $Output .= ' .. ';
          $PagesMin = $page - 10;
        }
        for ($i = $PagesMin; $i <= $PagesMax; $i++)
        {
          if ($i == $page) $Output .= '<strong>';
          $Output .= '<a href="index.php?page='.$i.'">'.($i + 1).'</a> ';
          if ($i == $page) $Output .= '</strong>';
        }
        if ($PagesMax < $Pages) $Output .= ' .. ';
        if ($page < $Pages) $Output .= '<a href="index.php?page='.($page + 1).'">&gt;</a> ';
        if ($page < $Pages) $Output .= '<a href="index.php?page='.$Pages.'">&gt;&gt;</a>';
      }
    }
    return $Output;
  }
}
